<?php

function draw_pagenumbers($startpage,$entries,$entries_per_page,$page_uri,$varname) {
	$startpage = intval($startpage);
	$entries   = intval($entries);

	if ($entries_per_page <= 0) $entries_per_page = 25;

	$last = $entries % $entries_per_page;
	$max_page =  (int)($entries / $entries_per_page);
	if ($last > 0) $max_page++;	 // max. Anzahl von Seiten
	$prepages = $startpage-1;
	if ($prepages > 5) $prepages = 5;
	$followpages = 10-1-$prepages;
	if ($followpages > 9) $followpages = 9;
	if (($followpages + $startpage) > $max_page) $followpages = $max_page - $startpage;
	if (($prepages + $followpages + 1) < $max_page) $prepages = 10 - $followpages - 1;
	if ($prepages >= $startpage) $prepages = $startpage - 1; // neu

	$endpage = $startpage+$followpages;
	$urlbind = strpos($page_uri,"?"); // Schauen ob schon Variablen angeh�ngt sind
	if ($urlbind === FALSE) {
		$urlbind = "?";
	} else {
		$urlbind = "&amp;";
	}
	// pagelink generieren
	$page_uri  = str_replace($urlbind.$varname."=".$startpage,"",$page_uri);

	// < und << davorsetzen
	if ((($startpage - 10) <= 0) && ($startpage > 2)) {
		echo "<a class=\"pagelink\" href=\"".$page_uri.$urlbind.$varname."=1\">&lt;&lt;</a>&nbsp;";
	} elseif ((($startpage - 10) > 0)) {
		echo "<a class=\"pagelink\" href=\"".$page_uri.$urlbind.$varname."=".($startpage-10)."\">&lt;&lt;</a>&nbsp;";
	}
	if ($startpage > 1) {
		echo "<a class=\"pagelink\" href=\"".$page_uri.$urlbind.$varname."=".($startpage-1)."\">&lt;</a>&nbsp;";
	}

	// Seitennummern inkl. pagelink ausgeben
	$pagenumber = $startpage - $prepages;
	while ($pagenumber <= $endpage) {
		if ($pagenumber != $startpage) {
			echo "<a class=\"pagelink\" href=\"".$page_uri.$urlbind.$varname."=".$pagenumber."\">$pagenumber</a>&nbsp;";
		} else {
			echo "<span class=\"currentpage\">".$pagenumber."&nbsp;</span>";
		}
		$pagenumber++;
	}

	// > und >> dahintersetzen
	if ($startpage < $max_page) {
		echo "<a class=\"pagelink\" href=\"".$page_uri.$urlbind.$varname."=".($startpage+1)."\">&gt;</a>&nbsp;";
	}
	if ((($startpage + 10) >= $max_page) && ($startpage+1 < $max_page)) {
		echo "<a class=\"pagelink\" href=\"".$page_uri.$urlbind.$varname."=".$max_page."\">&gt;&gt;</a>&nbsp;";
	} elseif ((($startpage + 10) < $max_page)) {
		echo "<a class=\"pagelink\" href=\"".$page_uri.$urlbind.$varname."=".($startpage+10)."\">&gt;&gt;</a>&nbsp;";
	}


}



function makeheader($title) {
	global $global_universe, $allyhistory, $playerhistory;
	@include "../languages/korean_workaround.inc.php";
	@include "../languages/taiwan_workaround.inc.php";
	@include "../languages/japanese_workaround.inc.php";
	@include "../languages/chinese_workaround.inc.php";

	// styles path holen
	if (isset($_SESSION['s_stylepath'])) $stylepath = $_SESSION['s_stylepath'];
	if (trim($stylepath) == "") $stylepath = "styles.css";

	$tmp = strrpos($stylepath,"/");
	$modname = "EpicBlue";
	if ($tmp !== false) {
		$tmp = substr($stylepath,0,$tmp);
		$pos = strrpos($tmp,"/");
		if ($pos !== false) $modname = substr($tmp,$pos+1,strlen($tmp)-$pos);
	}


	echo '
	<!doctype HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN">
	<html>
	<head>
	<meta http-equiv="content-type" content="text/html; charset=UTF-8">
	<title>'.$title.'</title>
	<link rel="stylesheet" type="text/css" href="'.$stylepath.'" />';
	echo '
	<script type="text/javascript" src="advajax.js"></script>
	<script type="text/javascript" src="common_scripts.js"></script>
	<script type="text/javascript" src="galaxytool.js"></script>
	<script type="text/javascript" src="tab_plugin.js"></script>
	<script type="text/javascript" src="pop_up.js"></script>
	<script type="text/javascript" src="js_tablesort/common.js"></script>
	<script type="text/javascript" src="js_tablesort/css.js"></script>
	<script type="text/javascript" src="js_tablesort/standardista-table-sorting.js"></script>
	</head>';
	if ($title == VIEW_TITLE) {
		echo '<body onKeyDown="cursorevent(event);" onload="Init()">';
	/*} elseif (isset($_GET['action']) && $_GET['action'] == "searchres" && (isset($_POST[urlencode(REPORTS_SEARCH_EXTENDED)]) || isset($_GET['page']))) {
		echo "<body>";
	} elseif ($title == USERINFO_TITLE || $title == DETAILEDINFO_ALLYINFO_TITLE) {
		echo "<body>"; */
	} else {
		echo '<body onload="Init()">';
	}

	if (isset($_SESSION['s_timezone_offset'])) {
		$hour_minutes = explode(":",$_SESSION['s_timezone_offset']);
		$offset = $hour_minutes[0];
		if ($hour_minutes[1] == "30") {
			$offset += 0.5;
		}
		echo '<script type="text/javascript">var TimezoneOffset = '.$offset.';</script>';
	}

	// for timeout issues
	echo '<iframe src="session.php" style="display:none; position:absolute; top:0px; left:0px; height:0px; width:0px">';
	echo '</iframe>';

	echo '<div class="dialog_window" id="dialog_window" style="display:none"></div>'."\n";
	echo'<div class="firstcolor" style="position:absolute; top:50px; left:10px; display: none; z-index: 998" id="loading" ><img alt="loading..." src="../images/loading_small.gif" border="0" /> Loading...</div>'."\n";

	echo '
	<table cellspacing="0" cellpadding="0" style="width:930px;" border="0" class="frameset">
	  <tr>
	    <td valign="top" style="width:172px;">
		<div class="copyright" style="width:120px; margin-left:26px; margin-top:26px;" align="center">'.SHORTNAME.'<br><a href="index.php?versionscheck" class="pagelink">'.VERSION.'</a><br>';
	// --------------------------------- BEGIN OF INFORMATION BLOCK ---------------------------------------------
	if (!empty($global_universe)) echo '<span class="mod">'.UNIVERSE.' '.$global_universe.'</span><br>';
	echo '<span class="mod">'.$modname.'-Mod</span></div>
	    <table class="menu" cellspacing="1" cellpadding="1" width="100%" border="0">
	    <tr><td class="tblhead">'.MENU_INFO_LINKS.'</td></tr>
	    <tr class="firstcolor"><td class="menu"><a class="menulink" href="index.php">'.MENU_PAGE.'</a></td></tr>'."\n";
	if ($_SESSION['s_cansearch']) {
		echo '    <tr class="firstcolor"><td class="menu"><a class="menulink" href="show.php">'.MENU_DB_SEARCH.'</a></td></tr>'."\n";
		echo '    <tr class="firstcolor"><td class="menu"><a class="menulink" href="notices.php?action=search">'.MENU_DB_NOTICES.'</a></td></tr>'."\n";
	}
	if ($_SESSION['s_probeview']) echo '    <tr class="firstcolor"><td class="menu"><a class="menulink" href="reports.php?action=search">'.MENU_DB_REPORTS.'</a></td></tr>'."\n";
	if ($_SESSION['s_cansearch']) {
		if (isset($_SESSION['s_gv_galaxy']) && isset($_SESSION['s_gv_system']))
		echo '    <tr class="firstcolor"><td class="menu"><a class="menulink" href="view.php?gala='.$_SESSION['s_gv_galaxy'].'&amp;system='.$_SESSION['s_gv_system'].'">'.MENU_GALAXYVIEW.'</a></td></tr>'."\n";
		else
		echo '    <tr class="firstcolor"><td class="menu"><a class="menulink" href="view.php?gala=1&amp;system=1">'.MENU_GALAXYVIEW.'</a></td></tr>'."\n";
	}

	echo '    <tr class="firstcolor"><td class="menu"><a class="menulink" href="stats.php">'.MENU_STATISTICS.'</a></td></tr>'."\n";
	if (($_SESSION['s_allyhistory'] === true) && (!empty($allyhistory) || !empty($playerhistory))) {
		echo '    <tr class="firstcolor"><td class="menu"><a class="menulink" href="allyhistory.php">'.MENU_ALLYHISTORY.'</a></td></tr>'."\n";
	}

	echo "</table>";

	// --------------------------------- END OF INFORMATION BLOCK ---------------------------------------------


	// --------------------------------- BEGIN OF OPTION BLOCK ---------------------------------------------
	echo '<table class="menu" cellspacing="1" cellpadding="1" width="100%" border="0">
    	  <tr><td class="tblhead">'.MENU_OPTION_LINKS.'</td></tr>';

	if ($_SESSION['s_caninsert']) echo '    <tr class="firstcolor"><td class="menu"><a class="menulink" href="einlesen.php">'.MENU_DB_REFRESH.'</a></td></tr>'."\n";

	if ($_SESSION['s_statusview']) {
		echo '    <tr class="firstcolor"><td class="menu"><a class="menulink" href="status.php">'.MENU_DB_STATUS.'</a></td></tr>'."\n";
	}

	if ($_SESSION['s_userman']) {
		echo '<tr class="firstcolor"><td class="menu"><a class="menulink" href="usermanagement.php">'.MENU_USEROPTIONS.'</a></td></tr>'."\n";
		echo '<tr class="firstcolor"><td class="menu"><a class="menulink" href="userinfo.php">'.MENU_USEROPTIONS3.'</a></td></tr>'."\n";
	}
	echo '<tr class="firstcolor"><td class="menu"><a class="menulink" href="change_password.php">'.MENU_USEROPTIONS2.'</a></td></tr>'."\n";
	if ($_SESSION['s_isadmin'] == true) {
		echo '<tr class="firstcolor"><td class="menu"><a class="menulink" href="administration.php">'.MENU_ADMIN.'</a></td></tr>'."\n";
	}

	// --------------------------------- END OF OPTION BLOCK ---------------------------------------------

	echo '
	    </table>';
	@include "../hosting/left_menu.php";

	// --------------------------------- BEGIN OF STUFF BLOCK ---------------------------------------------
	echo '
	    <table class="menu" cellspacing="1" cellpadding="1" width="100%" border="0">
	    <tr><td class="tblhead">'.MENU_STUFF.'</td></tr>
	    ';
	switch ($_SESSION['lang']) {
		case "german" :
			$help_url = "http://de.wiki.galaxytool.eu/";
			$download_url = "http://de.wiki.galaxytool.eu/index.php/Downloads";
			break;
		case "spanish" :
			$help_url = "http://es.wiki.galaxytool.eu/";
			$download_url = "http://es.wiki.galaxytool.eu/index.php/Descargar";
			break;

		default:
			$help_url = "http://en.wiki.galaxytool.eu/";
			$download_url = "http://en.wiki.galaxytool.eu/index.php/Downloads";
	}


	echo '
	    <tr class="firstcolor"><td class="menu"><a class="menulink" href="'.$help_url.'" target="_blank">'.MENU_HELP.'</a></td></tr>
	    <tr class="firstcolor"><td class="menu"><a class="menulink" href="http://board.galaxytool.eu" target="_blank">'.MENU_FORUM_THREAD.'</a></td></tr>
	    <tr class="firstcolor"><td class="menu"><a class="menulink" href="'.$download_url.'" target="_blank">'.MENU_DOWNLOADPAGE.'</a></td></tr>'."\n";

	if (isset($_SESSION['s_global_links'])) {
		foreach($_SESSION['s_global_links'] as $link) {
			if (!isset($link[1])) {
				echo '
	    		</table>
	    		<table class="menu" cellspacing="1" cellpadding="1" width="100%" border="0">
	    		<tr><td class="tblhead">'.$link[0].'</td></tr>';

			} else {
				echo '<tr class="firstcolor"><td class="menu"><a class="menulink" href="'.$link[1].'" target="_blank">'.$link[0].'</a></td></tr>'."\n";
			}
		}
	}

	if (isset($_SESSION['s_additional_links'])) {
		foreach($_SESSION['s_additional_links'] as $link) {
			if (!isset($link[1])) {
				echo '
	    		</table>
	    		<table class="menu" cellspacing="1" cellpadding="1" width="100%" border="0">
	    		<tr><td class="tblhead">'.$link[0].'</td></tr>';

			} else {
				echo '<tr class="firstcolor"><td class="menu"><a class="menulink" href="'.$link[1].'" target="_blank">'.$link[0].'</a></td></tr>'."\n";
			}
		}
	}

	echo '
	    </table>
	    <table class="menu" cellspacing="1" cellpadding="1" width="100%" border="0">
	    <tr><td class="tblhead">'.MENU_LANGUAGE.'</td></tr>
	    <tr class="firstcolor"><td align="center">
	    <form action="index.php" method="GET" accept-charset="utf-8">
	    <select class="pulldown_code" name="language">
          <option value="german" '; if ($_SESSION['lang'] == "german") echo "selected"; echo '>Deutsch</option>
          <option value="english" '; if ($_SESSION['lang'] == "english") echo "selected"; echo '>English</option>
          <option value="spanish" '; if ($_SESSION['lang'] == "spanish") echo "selected"; echo '>Español</option>
          <option value="dutch" '; if ($_SESSION['lang'] == "dutch") echo "selected"; echo '>Nederlands</option>
          <option value="balkan" '; if ($_SESSION['lang'] == "balkan") echo "selected"; echo '>Balkan</option>
          <option value="french" '; if ($_SESSION['lang'] == "french") echo "selected"; echo '>Français</option>
          <option value="portugues" '; if ($_SESSION['lang'] == "portugues") echo "selected"; echo '>Português</option>
          <option value="polish" '; if ($_SESSION['lang'] == "polish") echo "selected"; echo '>Polski</option>
          <option value="italian" '; if ($_SESSION['lang'] == "italian") echo "selected"; echo '>Italiano</option>
          <option value="turkish" '; if ($_SESSION['lang'] == "turkish") echo "selected"; echo '>Türkçe</option>
          <option value="danish" '; if ($_SESSION['lang'] == "danish") echo "selected"; echo '>Dansk</option>
          <option value="brazilian" '; if ($_SESSION['lang'] == "brazilian") echo "selected"; echo '>Brazilian</option>
          <option value="russian" '; if ($_SESSION['lang'] == "russian") echo "selected"; echo '>Русский</option>
          <option value="swedish" '; if ($_SESSION['lang'] == "swedish") echo "selected"; echo '>Svenska</option>
          <option value="greek" '; if ($_SESSION['lang'] == "greek") echo "selected"; echo '>Ελληνικά</option>
          <option value="romanian" '; if ($_SESSION['lang'] == "romanian") echo "selected"; echo '>Română</option>
          <option value="hungarian" '; if ($_SESSION['lang'] == "hungarian") echo "selected"; echo '>Magyar</option>
          <option value="czech" '; if ($_SESSION['lang'] == "czech") echo "selected"; echo '>Čeština</option>
          <option value="korean" '; if ($_SESSION['lang'] == "korean") echo "selected"; echo '>'.$korean.'</option>
          <option value="norwegian" '; if ($_SESSION['lang'] == "norwegian") echo "selected"; echo '>Norsk bokmål</option>
          <option value="taiwan" '; if ($_SESSION['lang'] == "taiwan") echo "selected"; echo '>'.$taiwan.'</option>
          <option value="japan" '; if ($_SESSION['lang'] == "japan") echo "selected"; echo '>'.$japan.'</option>
          <option value="chinese" '; if ($_SESSION['lang'] == "chinese") echo "selected"; echo '>'.$chinese.'</option>
          <option value="bulgarian" '; if ($_SESSION['lang'] == "bulgarian") echo "selected"; echo '>Български</option>
          <option value="lithuanian" '; if ($_SESSION['lang'] == "lithuanian") echo "selected"; echo '>lietuvių kalba</option>
          <option value="latvian" '; if ($_SESSION['lang'] == "latvian") echo "selected"; echo '>Latvian</option>
          <option value="finnish" '; if ($_SESSION['lang'] == "finnish") echo "selected"; echo '>Suomi</option>
          <option value="slovak" '; if ($_SESSION['lang'] == "slovak") echo "selected"; echo '> Slovenčina</option>
          </select>&nbsp;
          <input class="button" type="submit" name="OK" value="OK" />
          </form>
          </td></tr>
	    <tr class="firstcolor"><td class="menu"><a class="menulink" href="../index.php?logout">'.MENU_LOGOUT.'</a></td></tr>
	    </table>';

	echo '
	    </td>
	    <td valign="top" class="mainframe" style="width:628px;">
	    ';
	@include "../hosting/mainframe_top.php";
	// --------------------------------- END OF STUFF BLOCK ---------------------------------------------
}


function makefooter() {
	@include "../hosting/mainframe_bottom.php";
	echo '
	    </td>
	    <td style=" padding-top:50px;width:130px;">&nbsp;</td>
	  </tr>
	</table>
	<div style="position:absolute; top:50px; left:10px; display: none; z-index: 999" id="popup" ></div>
	<script type="text/javascript" src="wz_tooltip.js"></script>
	</body>
	</html>';
}

function get_player_status_string($banned,$vacation,$noob,$inactive,$long_inactive,$show_as_bb_string=false) {
	$status = "";
	if (!$show_as_bb_string) {
		if ($banned != "false") {
			$status .= "<span class=\"banned\">".PLAYER_BANNED."</span>";
		}
		if ($vacation != "false") {
			$status .= "<span class=\"vacation\">".PLAYER_VACATION_MODE."</span>";
		}
		if ($noob != "false") {
			$status .= "<span class=\"noob\">".PLAYER_NOOB."</span>";
		}
		if ($inactive != "false") {
			$status .= "<span class=\"inactive\">".PLAYER_INACTIVE."</span>";
		}
		if ($long_inactive != "false") {
			$status .= "<span class=\"longinactive\">".PLAYER_LONG_INACTIVE."</span>";
		}

	} else {
		if ($banned != "false") {
			$status .=  "[COLOR=".$_SESSION['s_bb_banned']."]".$printbanned."[/COLOR]";
		}
		if ($vacation != "false") {
			$status .=  "[COLOR=".$_SESSION['s_bb_vacation']."]".$printvaction."[/COLOR]";
		}
		if ($noob != "false") {
			$status .=  "[COLOR=".$_SESSION['s_bb_noob']."]".$printnoob."[/COLOR]";
		}
		if ($inactive != "false") {
			$status .=  "[COLOR=".$_SESSION['s_bb_inactive']."]".$printinactive."[/COLOR]";
		}
		if ($long_inactive != "false") {
			$status .=  "[COLOR=".$_SESSION['s_bb_longinactive']."]".$printlonginactive."[/COLOR]";
		}
	}

	return $status;
}

function get_player_with_status_color($playername,$banned,$vacation,$noob,$inactive,$long_inactive) {
	if (trim($playername) == "") return "";
	
	$status = "";
	$openspans = 0;

	if ($banned != "false") {
		$status .= "<span class=\"banned\">";
		$openspans++;
	}
	if ($vacation != "false") {
		$status .= "<span class=\"vacation\">";
		$openspans++;
	} elseif ($noob != "false") {
		$status .= "<span class=\"noob\">";
		$openspans++;
	} elseif ($inactive != "false") {
		$status .= "<span class=\"longinactive\">";
		$openspans++;
	} elseif ($long_inactive != "false") {
		$status .= "<span class=\"inactive\">";
		$openspans++;
	}

	$status .= $playername;
	for ($i=$openspans;$i>0;$i--) {
		$status .= "</span>";
	}

	return $status;
}

function update_dragosim_link($link,$key,$value) {
	if (empty($link)) {
		global $def_to_debris, $debris_rate, $speed_rate;
		
		$link = "http://drago-sim.com/?referrer=galaxytool&amp;";
		
		// debris ratio needs to be between 0 and 1 at dragosim
		$link .= "debris_ratio=".($debris_rate / 100)."&amp;";
		
		if ($def_to_debris === true) {
			$link .= "def_tf=0&amp;"; // dragosim wants 0 to set the checkbox as of now
		}
		
		switch ($_SESSION['lang']) {
			case "german" :
				$link .= "lang=german&amp;";
				break;
			case "polish" :
				$link .= "lang=polish&amp;";
				break;
			case "english" :
				$link .= "lang=english&amp;";
				break;
			case "spanish" :
				$link .= "lang=spanish&amp;";
				break;
			case "dutch" :
				$link .= "lang=dutch&amp;";
				break;
			case "balkan" :
				$link .= "lang=bosnian&amp;";
				break;
			case "french" :
				$link .= "lang=french&amp;";
				break;
			case "portugues" :
				$link .= "lang=portuguese&amp;";
				break;
			case "italian" :
				$link .= "lang=italian&amp;";
				break;
			case "turkish" :
				$link .= "lang=turkish&amp;";
				break;
			case "danish" :
				$link .= "lang=danish&amp;";
				break;
			case "brazilian" :
				$link .= "lang=brazilian&amp;";
				break;
			case "russian" :
				$link .= "lang=russian&amp;";
				break;
			case "swedish" :
				$link .= "lang=swedish&amp;";
				break;
			case "greek" :
				$link .= "lang=greek&amp;";
				break;
			case "romanian" :
				$link .= "lang=romanian&amp;";
				break;
			case "hungarian" :
				$link .= "lang=hungarian&amp;";
				break;
			case "czech" :
				$link .= "lang=czech&amp;";
				break;
			case "korean" :
				$link .= "lang=korean&amp;";
				break;
			case "norwegian" :
				// nothing yet
				break;
			case "taiwan" :
				$link .= "lang=taiwanese&amp;";
				break;
			case "japan" :
				// nothing yet
				break;
			case "chinese" :
				// noting yet
				break;
			case "bulgarian" :
				$link .= "lang=bulgarian&amp;";
				break;
			case "lithuanian" :
				// nothing yet
				break;
			case "latvian" :
				// not available yet
				break;
			case "finnish" :
				// not available yet
				break;
			case "slovak" :
				// not available yet
				break;
			default: break;
		}

		if ($_SESSION['s_waffentech'] > 0) {
			$link .= "techs[0][0][w_t]=".$_SESSION['s_waffentech']."&amp;";
		}
		if ($_SESSION['s_schildtech'] > 0) {
			$link .= "techs[0][0][s_t]=".$_SESSION['s_schildtech']."&amp;";
		}
		if ($_SESSION['s_rpz'] > 0) {
			$link .= "techs[0][0][r_p]=".$_SESSION['s_rpz']."&amp;";
		}
	}

	if ($value > 0 || $key == "coordinates" || $key == "enemy_name") {
		switch ($key) {
			case "coordinates": $link .= "v_coords=$value&amp;"; break;
			case "enemy_name":  $link .= "v_planet=$value&amp;"; break;

			case "metal":      $link .= "v_met=$value&amp;"; break;
			case "crystal":    $link .= "v_kris=$value&amp;"; break;
			case "deuterium":  $link .= "v_deut=$value&amp;"; break;

			case "kt":         $link .= "numunits[1][0][k_t]=$value&amp;"; break;
			case "gt":         $link .= "numunits[1][0][g_t]=$value&amp;"; break;
			case "lj":         $link .= "numunits[1][0][l_j]=$value&amp;"; break;
			case "sj":         $link .= "numunits[1][0][s_j]=$value&amp;"; break;
			case "krz":        $link .= "numunits[1][0][kr]=$value&amp;"; break;
			case "ss":         $link .= "numunits[1][0][sc]=$value&amp;"; break;
			case "kolo":       $link .= "numunits[1][0][ko]=$value&amp;"; break;
			case "rec":        $link .= "numunits[1][0][re]=$value&amp;"; break;
			case "spio":       $link .= "numunits[1][0][sp]=$value&amp;"; break;
			case "bomb":       $link .= "numunits[1][0][bo]=$value&amp;"; break;
			case "sat":        $link .= "numunits[1][0][so]=$value&amp;"; break;
			case "zerri":      $link .= "numunits[1][0][z]=$value&amp;"; break;
			case "ds": 		   $link .= "numunits[1][0][t]=$value&amp;"; break;
			case "skrz": 	   $link .= "numunits[1][0][sk]=$value&amp;"; break;

			case "rak": 	   $link .= "numunits[1][0][ra]=$value&amp;"; break;
			case "ll": 		   $link .= "numunits[1][0][l_l]=$value&amp;"; break;
			case "sl": 		   $link .= "numunits[1][0][s_l]=$value&amp;"; break;
			case "gauss": 	   $link .= "numunits[1][0][g]=$value&amp;"; break;
			case "ion": 	   $link .= "numunits[1][0][i]=$value&amp;"; break;
			case "plasma": 	   $link .= "numunits[1][0][p]=$value&amp;"; break;
			case "ksk": 	   $link .= "numunits[1][0][k_s]=$value&amp;"; break;
			case "gsk": 	   $link .= "numunits[1][0][g_s]=$value&amp;"; break;

			case "waffentech": $link .= "techs[1][0][w_t]=$value&amp;"; break;
			case "schildtech": $link .= "techs[1][0][s_t]=$value&amp;"; break;
			case "rpz": 	   $link .= "techs[1][0][r_p]=$value&amp;"; break;

			case "arak":       $link .= "missiles_available_v=$value&amp;"; break;

		}

	}

	return $link;
}


function update_speedsim_link($link,$key,$value) {
	if (empty($link)) {
		global $def_to_debris, $debris_rate, $speed_rate;
		$link = "http://websim.speedsim.net/?";
		
		// def to debris
		if ($def_to_debris === true) {
			$link .= "def_to_df=1&amp;";	
		} else {
			$link .= "def_to_df=0&amp;";
		}
		
		// debris ratio
		$link .= "perc-df=$debris_rate&amp;";
		
  
	}
	//?ship_d0_3_b=4&tech_a0_0=10&tech_d0_1=12&engine_0=10&ship_d0_18_b=1&engine0_0=10&enemy_metal=10.000
	if ($value > 0 || $key == "coordinates" || $key == "enemy_name") {
		switch ($key) {
			case "coordinates": $link .= "enemy_pos=$value&amp;"; break;
			case "enemy_name":  $link .= "enemy_name=$value&amp;"; break;

			case "metal":      $link .= "enemy_metal=$value&amp;"; break;
			case "crystal":    $link .= "enemy_crystal=$value&amp;"; break;
			case "deuterium":  $link .= "enemy_deut=$value&amp;"; break;

			case "kt":         $link .= "ship_d0_0_b=$value&amp;"; break;
			case "gt":         $link .= "ship_d0_1_b=$value&amp;"; break;
			case "lj":         $link .= "ship_d0_2_b=$value&amp;"; break;
			case "sj":         $link .= "ship_d0_3_b=$value&amp;"; break;
			case "krz":        $link .= "ship_d0_4_b=$value&amp;"; break;
			case "ss":         $link .= "ship_d0_5_b=$value&amp;"; break;
			case "kolo":       $link .= "ship_d0_6_b=$value&amp;"; break;
			case "rec":        $link .= "ship_d0_7_b=$value&amp;"; break;
			case "spio":       $link .= "ship_d0_8_b=$value&amp;"; break;
			case "bomb":       $link .= "ship_d0_9_b=$value&amp;"; break;
			case "sat":        $link .= "ship_d0_10_b=$value&amp;"; break;
			case "zerri":      $link .= "ship_d0_11_b=$value&amp;"; break;
			case "ds": 		   $link .= "ship_d0_12_b=$value&amp;"; break;
			case "skrz": 	   $link .= "ship_d0_13_b=$value&amp;"; break;

			case "rak": 	   $link .= "ship_d0_14_b=$value&amp;"; break;
			case "ll": 		   $link .= "ship_d0_15_b=$value&amp;"; break;
			case "sl": 		   $link .= "ship_d0_16_b=$value&amp;"; break;
			case "gauss": 	   $link .= "ship_d0_17_b=$value&amp;"; break;
			case "ion": 	   $link .= "ship_d0_18_b=$value&amp;"; break;
			case "plasma": 	   $link .= "ship_d0_19_b=$value&amp;"; break;
			case "ksk": 	   $link .= "ship_d0_20_b=$value&amp;"; break;
			case "gsk": 	   $link .= "ship_d0_21_b=$value&amp;"; break;

			case "waffentech": $link .= "tech_d0_0=$value&amp;"; break;
			case "schildtech": $link .= "tech_d0_1=$value&amp;"; break;
			case "rpz": 	   $link .= "tech_d0_2=$value&amp;"; break;

			case "arak":       $link .= "abm_b=$value&amp;"; break;

		}

		if ($_SESSION['s_vbt'] > 0 && !strpos($link,"engine0_0=")) {
			$link .= "engine0_0=".$_SESSION['s_vbt']."&amp;";
		}
		if ($_SESSION['s_impulse'] > 0 && !strpos($link,"engine0_1=")) {
			$link .= "engine0_1=".$_SESSION['s_impulse']."&amp;";
		}
		if ($_SESSION['s_hra'] > 0 && !strpos($link,"engine0_2=")) {
			$link .= "engine0_2=".$_SESSION['s_hra']."&amp;";
		}

		if ($_SESSION['s_waffentech'] > 0 && !strpos($link,"tech_a0_0=")) {
			$link .= "tech_a0_0=".$_SESSION['s_waffentech']."&amp;";
		}
		if ($_SESSION['s_schildtech'] > 0 && !strpos($link,"tech_a0_1=")) {
			$link .= "tech_a0_1=".$_SESSION['s_schildtech']."&amp;";
		}
		if ($_SESSION['s_rpz'] > 0 && !strpos($link,"tech_a0_2=")) {
			$link .= "tech_a0_2=".$_SESSION['s_rpz']."&amp;";
		}
		if (!strpos($link,"lang=")) {
			switch ($_SESSION['lang']) {
				case "german" :
					$link .= "lang=de&amp;";
					break;
				case "polish" :
					$link .= "lang=pl&amp;";
					break;
				case "english" :
					$link .= "lang=en&amp;";
					break;
				case "spanish" :
					$link .= "lang=sp&amp;";
					break;
				case "dutch" :
					$link .= "lang=nl&amp;";
					break;
				case "balkan" :
					$link .= "lang=ba&amp;";
					break;
				case "french" :
					$link .= "lang=fr&amp;";
					break;
				case "portugues" :
					$link .= "lang=pt&amp;";
					break;
				case "italian" :
					$link .= "lang=it&amp;";
					break;
				case "turkish" :
					// nothing yet
					break;
				case "danish" :
					$link .= "lang=dk&amp;";
					break;
				case "brazilian" :
					$link .= "lang=pt&amp;"; // no brazil yet, but pt is better than german
					break;
				case "russian" :
					$link .= "lang=ru&amp;";
					break;
				case "swedish" :
					$link .= "lang=sv&amp;";
					break;
				case "greek" :
					$link .= "lang=gr&amp;";
					break;
				case "romanian" :
					$link .= "lang=ro&amp;";
					break;
				case "hungarian" :
					// nothing available yet
					break;
				case "czech" :
					$link .= "lang=cz&amp;";
					break;
				case "korean" :
					$link .= "lang=kr&amp;";
					break;
				case "norwegian" :
					$link .= "lang=no&amp;";
					break;
				case "taiwan" :
					$link .= "lang=tw&amp;";
					break;
				case "japan" :
					$link .= "lang=ja&amp;";
					break;
				case "chinese" :
					$link .= "lang=cn&amp;";
					break;
				case "bulgarian" :
					$link .= "lang=bg&amp;";
					break;
				case "lithuanian" :
					$link .= "lang=lt&amp;";
					break;
				case "latvian" :
					// not available yet
					break;
				case "finnish" :
					// not available yet
					break;
				case "slovak" :
					// not available yet
					break;
				default: break;
			}

		}

	}
	return $link;
}



function get_phalanx_range($moon_array) {
	ksort($moon_array); // sort array by galaxy key
	$range_array = array();

	foreach ($moon_array as $galaxy => $values) {
		usort($values,"compare_moon_array");
		$phalanx_string[$galaxy] = "";
		$biggest_max_system = 0;

		for ($i=0;$i<count($values);$i++) {
			if ($biggest_max_system == 0) {
				$phalanx_string[$galaxy] .= $galaxy.":".$values[$i]['min']." - ";
			} else {
				if ($biggest_max_system < ($values[$i]['min']-1)) { // -1 to have 1:211 - 1:343 + 1:344 - 1:452 like 1:211 - 1:452
					$phalanx_string[$galaxy] .= $galaxy.":$biggest_max_system + $galaxy:".$values[$i]['min']." - ";
				}
			}
			if ($biggest_max_system < $values[$i]['max']) {
				$biggest_max_system = $values[$i]['max'];
			}

			if ($i == count($values) - 1) { // last entry
				$phalanx_string[$galaxy] .= $galaxy.":".$biggest_max_system;
			}
		}
	}

	return $phalanx_string;
}


function compare_moon_array($a, $b) {
	if ($a["min"] == $b["min"]) {
		return 0;
	}
	return ($a["min"] < $b["min"]) ? -1 : 1;
}


function compare_galaxy_array($a, $b) {
	if ($a["key"] == $b["key"]) {
		return 0;
	}
	$a_parts = explode(":",$a["key"]);
	$b_parts = explode(":",$b["key"]);
	
	// convert to integer
	for ($i = 0; $i < 3; $i++) {
		$a_parts[$i] = intval($a_parts[$i]);
		$b_parts[$i] = intval($b_parts[$i]);
	}

	if ($a_parts[0] > $b_parts[0]) {
		return 1;
	} elseif ($a_parts[0] < $b_parts[0]) {
		return -1;
	} else {

		if ($a_parts[1] > $b_parts[1]) {
			return 1;
		} elseif ($a_parts[1] < $b_parts[1]) {
			return -1;
		} else {

			if ($a_parts[2] > $b_parts[2]) {
				return 1;
			} elseif ($a_parts[2] < $b_parts[2]) {
				return -1;
			} else {
				return 0;
			}

		}
	}

}

function set_form_options($formnames) {

	if (!is_array($formnames) || count($formnames) == 0) {
		return;
	}

	if (isset($_SESSION['s_saves'])) {
		echo "<pre>";
		print_r($_SESSION['s_saves']);
		echo "</pre>";
	}
	return;

}

function show_form_options($folder) {

	$display_load_and_delete = (isset($_SESSION['s_saves'][$folder])) ? "inline" : "none";
	echo '
	<a id="save_form" href="#"><img src="../images/save.gif" onclick="ShowObject(\'dialog_window\',\'ajax_forms.php?action=save&folder='.$folder.'\',false)" border="0" width="16" height="16" /></a>&nbsp;
	<a id="load_form" style="display:'.$display_load_and_delete.'" href="#"><img src="../images/open.gif" onclick="ShowObject(\'dialog_window\',\'ajax_forms.php?action=open&folder='.$folder.'\',false)" border="0" width="16" height="16" /></a>&nbsp;
	';	
}


function pulldowncode($name,$startval,$endval,$interval,$selected=0,$id="") {
	echo "<select name=\"$name\" ";
	if (!empty($id)) echo " id=\"$id\" ";
	echo "class=\"pulldown_code\">\n";
	for ($i=$startval;$i<=$endval;$i += $interval) {
		echo "<option value=\"$i\"";
		if ($selected == $i) echo "selected";
		echo ">$i</option>\n";
	}
	echo "</select>\n";
}

function get_report_group($key) {
	switch($key) {
		case "metal":
		case "crystal":
		case "deuterium":
		case "energy": return "resources";
		case "kt":
		case "gt":
		case "lj":
		case "sj":
		case "krz":
		case "ss":
		case "kolo":
		case "rec":
		case "spio":
		case "bomb":
		case "zerri":
		case "ds":
		case "skrz":
		case "sat": return "fleet";
		case "rak":
		case "ll":
		case "sl":
		case "ion":
		case "gauss":
		case "plasma":
		case "ksk":
		case "gsk":
		case "arak":
		case "irak": return "defence";
		case "memi":
		case "krimi":
		case "deutsyn":
		case "solar":
		case "fusion":
		case "robo":
		case "nani":
		case "rawe":
		case "mesp":
		case "krissp":
		case "deutsp":
		case "folab":
		case "terra":
		case "allydep":
		case "raksilo":
		case "mbase":
		case "sensor":
		case "sprungtor": return "buildings";
		case "spiolvl":
		case "computech":
		case "waffentech":
		case "schildtech":
		case "rpz":
		case "energytech":
		case "hypertech":
		case "vbt":
		case "impulse":
		case "hra":
		case "lasertech":
		case "iontech":
		case "plasmatech":
		case "forschungsnetz":
		case "expedition":
		case "gravi": return "research";

		echo "Missing entry at functions.inc.php<br>";
		return -1;

	}



}


?>
